"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reviver = exports.replacer = void 0;
const replacer = (_, value) => {
    if (value instanceof RegExp)
        return `__REGEXP ${value.toString()}`;
    if (typeof value === 'function')
        return `__FUNCTION ${value.toString()}`;
    return value;
};
exports.replacer = replacer;
const reviver = (_, value) => {
    if (value.toString().includes('__REGEXP ')) {
        const match = /\/(.*)\/(.*)?/.exec(value.split('__REGEXP ')[1]);
        return new RegExp(match[1], match[2] || '');
    }
    if (value.toString().includes('__FUNCTION ')) {
        // eslint-disable-next-line @typescript-eslint/no-implied-eval
        return new Function(`return (${value.split('__FUNCTION ')[1]}).apply(this, arguments)`);
    }
    return value;
};
exports.reviver = reviver;
//# sourceMappingURL=helpers.js.map